#ifndef _DLL_H_
#define _DLL_H_

int		SamplesToCoefficients
				(
					float	*Image,		/* in-place processing */
					long	Width,		/* width of the image */
					long	Height,		/* height of the image */
					long	SplineDegree/* degree of the spline model */
				);

double	InterpolatedValue
				(
					float	*Bcoeff,	/* input B-spline array of coefficients */
					long	Width,		/* width of the image */
					long	Height,		/* height of the image */
					double	x,			/* x coordinate where to interpolate */
					double	y,			/* y coordinate where to interpolate */
					long	SplineDegree/* degree of the spline model */
				);


extern "C"
{
   __declspec(dllexport) int Translate(int dim, int dim_x, int dim_y, double* a, double* shifts, int spline_degree, double* b);
   __declspec(dllexport) int Rotate(int dim, int dim_x, int dim_y, double* a, double* axis, double angle, int spline_degree, double* b);
   __declspec(dllexport) int Scale(int dim, int dim_x, int dim_y, double* a, double* center, double factor, int spline_degree, double* b);
}

#endif

