# -*- coding: iso_8859_1 -*-

import pyfits
import numpy as np
import os

def getdata(sFolder, sImagelist, format=np.float32, text_display=''):

	if text_display!='silent':
		print
		print "--- loading FITS data ---"
	#loading images
	for i, sImage in enumerate(sImagelist):
	
		if text_display!='silent':
			print sImage
		hdulist = pyfits.open(sFolder + sImage)
			
		if i==0:
			imagedata = hdulist[0].data
			if len(sImagelist)==1:
				imagedata = np.tile(imagedata,(1,1))
			else:
				imagedata = np.tile(imagedata,(len(sImagelist),1,1))
		else:
			imagedata[i,:,:] = hdulist[0].data

	hdulist.close()
		
	return np.array(imagedata, dtype=format)
	

def getheaders(sFolder, sImagelist, text_display=''):
	
	if text_display!='silent':
		print 
		print "--- loading FITS headers ---"
	imageheader = []
	
	#loading images
	for i, sImage in enumerate(sImagelist):
	
		if text_display!='silent':
			print sImage
		hdulist = pyfits.open(sFolder + sImage)
		
		if i==0:
			imageheader = [hdulist[0].header.ascardlist()]
		else:
			imageheader[len(imageheader):] = [hdulist[0].header.ascardlist()]
	hdulist.close()
		
	return imageheader
	
def getheadervalues(sFolder, sImagelist, sHeader):
	
	headervalues = []
	
	#loading images
	for i, sImage in enumerate(sImagelist):
	
		hdulist = pyfits.open(sFolder + sImage)
		headervalues.append(hdulist[0].header[sHeader])

	hdulist.close()
		
	return headervalues

	
def check_extension(file_name):
	ext = os.path.splitext(file_name)[1]
	if (ext==".fit") or (ext==".fits"):
		answer = True
	else:
		answer = False
	return answer