# -*- coding: iso_8859_1 -*-

import time, sys
import numpy as np
import matplotlib.pyplot as plt
import load, displaying, process, process2


def select_stars(Folder, Imagelist, threshold, psf_fit_area, images_aligned='no'):

	print
	print '---------------------------------------------------------------------'
	print '      script for star selection'
	print '---------------------------------------------------------------------'
	
	time_format = "%Y-%m-%dT%H:%M:%S"

	#------------------------------------------------------------------------------------
	#	selecting one moving object
	#------------------------------------------------------------------------------------

	print
	print 'Is there a moving object ?'
	answer = raw_input('yes or no = ')

	if answer=='yes':
		image1 = load.getdata(Folder, [Imagelist[0]])
		date1 = load.getheadervalues(Folder, [Imagelist[0]], 'DATE-OBS')
		t1 = time.mktime(time.strptime(date1[0].split('.')[0],time_format))
		displaying.display(image1)
		print
		print 'Specify position of moving object on first image'
		x1 = np.int(raw_input('x position (vertical): x1 = '))
		y1 = np.int(raw_input('y position (horizontal): y1 = '))
		plt.close()

		if 	(x1-psf_fit_area<0)or(x1+psf_fit_area+1>image1.shape[0])or(y1-psf_fit_area<0)or(y1+psf_fit_area+1>image1.shape[1]):
			print 'object is too close from image border'
			print 'x1 and y1 must be >= ',psf_fit_area
			print 'x1 must be <= ',image1.shape[0]-psf_fit_area-1
			print 'y1 must be <= ',image1.shape[1]-psf_fit_area-1
			raw_input('script is terminated: press ENTER to close window')
			sys.exit()
		else:
			p1 = process.fit_gauss_elliptical([x1-psf_fit_area,y1-psf_fit_area],image1[x1-psf_fit_area:x1+psf_fit_area+1, y1-psf_fit_area:y1+psf_fit_area+1])

		image2 = load.getdata(Folder, [Imagelist[-1]])
		date2 = load.getheadervalues(Folder, [Imagelist[-1]], 'DATE-OBS')
		t2 = time.mktime(time.strptime(date2[0].split('.')[0],time_format))
		displaying.display(image2)
		print
		print 'Specify position of moving object on last image'
		x2 = np.int(raw_input('x position (vertical): x2 = '))
		y2 = np.int(raw_input('y position (horizontal): y2 = '))
		plt.close()

		if 	(x2-psf_fit_area<0)or(x2+psf_fit_area+1>image2.shape[0])or(y2-psf_fit_area<0)or(y2+psf_fit_area+1>image2.shape[1]):
			print 'object is too close from image border'
			print 'x2 and y2 must be >= ',psf_fit_area
			print 'x2 must be <= ',image2.shape[0]-psf_fit_area-1
			print 'y2 must be <= ',image2.shape[1]-psf_fit_area-1
			raw_input('script is terminated: press ENTER to close window')
			sys.exit()
		else:
			p2 = process.fit_gauss_elliptical([x2-psf_fit_area,y2-psf_fit_area],image2[x2-psf_fit_area:x2+psf_fit_area+1, y2-psf_fit_area:y2+psf_fit_area+1])

		if images_aligned == 'no':
			xs, ys = process2.find_shift_stars_matching(image1, image2, threshold, psf_fit_area, excluded = [x1-10, x1+10, y1-10, y1+10])
		else:
			xs = 0.
			ys = 0.
			
		#--- collecting information ---
		x = [p1[3]]
		y = [p1[4]]
		dx = [(p2[3]-p1[3]-xs)/(t2-t1)]
		dy = [(p2[4]-p1[4]-ys)/(t2-t1)]
		names = ['moving_object']
		excluded = [p1[3]-10,p1[3]+10,p1[4]-10,p1[4]+10]

	else:
		image1 = load.getdata(Folder, [Imagelist[0]])
		t1 = 0.

		#--- collecting information ---
		x=[]		#X-Y positions on 1st image
		y=[]
		dx=[]		#X-Y positions change per unit time
		dy=[]
		names = []
		excluded = []
	
	#------------------------------------------------------------------------------------
	#	selecting stars
	#------------------------------------------------------------------------------------

	print
	print 'How many stars do you want to analyse ?'
	nb = np.int(raw_input('nb of stars = '))

	if nb>0:
		displaying.display(image1)

		for i in range(nb):
			print
			print 'Select star',i+1,' to be analysed'
			x1 = np.int(raw_input('x position (vertical) = '))
			y1 = np.int(raw_input('y position (horizontal) = '))

			if 	(x1-psf_fit_area<0)or(x1+psf_fit_area+1>image1.shape[0])or(y1-psf_fit_area<0)or(y1+psf_fit_area+1>image1.shape[1]):
				print 'object is too close from image border'
				print 'x1 and y1 must be >= ',psf_fit_area
				print 'x1 must be <= ',image1.shape[0]-psf_fit_area-1
				print 'y1 must be <= ',image1.shape[1]-psf_fit_area-1
				raw_input('script is terminated: press ENTER to close window')
				sys.exit()
			else:
				p1 = process.fit_gauss_elliptical([x1-psf_fit_area,y1-psf_fit_area],image1[x1-psf_fit_area:x1+psf_fit_area+1, y1-psf_fit_area:y1+psf_fit_area+1])

			x.append(p1[3])
			y.append(p1[4])
			dx.append(0.)
			dy.append(0.)
			names.append('star_'+str(i+1))

		plt.close()

	if len(x)==0:
		print
		raw_input('no object has been selected, press ENTER to close window')
		sys.exit()

	#------------------------------------------------------------------------------------
	#	calculating image shifts
	#------------------------------------------------------------------------------------

	print
	print '---------------------------------------------------------------------'

	xy = []
	for i in range(len(Imagelist)):					#loop on images
	
		if i==0:
			image = image1
			xy_image = [[x[j],y[j]] for j in range(len(x))]
		else:
			image = load.getdata(Folder, [Imagelist[i]], text_display='silent')
			date = load.getheadervalues(Folder, [Imagelist[i]], 'DATE-OBS')
			t = time.mktime(time.strptime(date[0].split('.')[0],time_format))		
			if images_aligned == 'no':
				print 'calculating shift of :',Imagelist[i]
				xs, ys = process2.find_shift_stars_matching(image1, image, threshold, psf_fit_area, excluded)
			else:
				xs = 0.
				ys = 0.
			
			xy_image = []
			for j in range(len(x)):						#loop on stars
				if images_aligned == 'no':
					xy_image.append([x[j]+xs+(t-t1)*dx[j], y[j]+ys+(t-t1)*dy[j]])
				else:
					xy_image.append([x[j]+(t-t1)*dx[j], y[j]+(t-t1)*dy[j]])

		xy.append(xy_image)

	return names, xy
