# -*- coding: iso_8859_1 -*-

import pyfits
import os
import numpy as np


def save_fits(image0, headerlist, path):

	#--- conditioning data ---
	if len(image0.shape)==3:
		image0 = image0[0,:,:]
	image0 = np.array(np.round(image0,0),dtype=np.int16)

	#--- create FITS ---
	hdu = pyfits.PrimaryHDU()
	hdu.data = image0
	del hdu.header['EXTEND']
	for hh in headerlist:
		hdu.header.update(hh[0],hh[1],hh[2])

	#--- save FITS ---
	if os.path.exists(path):
		os.remove(path)
	hdu.writeto(path)
	return 0