# -*- coding: iso_8859_1 -*-

import astro
import numpy as np
import matplotlib.pyplot as plt

#------------------------------------------------------------------------------------
#	input parameters
#------------------------------------------------------------------------------------

Folder = u"C:\\Documents and Settings\\jerome caron\\Desktop\\Perso astro\\21fev2011\\"

#--- images ---
Darklist = ["sources\\dark\\dark-" + str(i+1) + ".fit" for i in range(20)]
Flat = "sources\\flat-final.fit"
Imagelist = ["sources\\Chryseis\\Chryseis-" + str(i+1) + ".fit" for i in range(41)]

#--- additional information (for FITS headers) ---
Obj = 'NGC891'

#parameters to find image shifts
threshold = 0.01		#percentage of min-max dynamic range for star detection
psf_fit_area = 12		#+/- size of square subimage for PSF fitting

#------------------------------------------------------------------------------------
#	processing
#------------------------------------------------------------------------------------

#--- loading all images ---
darks = astro.getdata(Folder, Darklist)
flat = astro.getdata(Folder, Flat)
images = astro.getdata(Folder, Imagelist)

#--- radiometric calibration ---
dark_final = astro.add_sigma_clipping(darks, 3., 1)
images_calib = (images - np.tile(dark_final,(len(Imagelist),1,1))) * astro.get_median(flat) / np.tile(flat,(len(Imagelist),1,1))

#--- co-registration and co-addition ---
images_aligned = images_calib

for i in range(1,len(Imagelist)):
	dx,dy = astro.find_shift_stars_matching(images_calib[0,:,:], images_calib[i,:,:], threshold, psf_fit_area)
	images_aligned[i,:,:] = astro.translate_bilinear(images_calib[i,:,:], (-dx,-dy))

image_final = astro.add_sigma_clipping(images_aligned, 3., 1)

#--- creating headers for final image ---
Exp = astro.getheadervalues(Folder, Imagelist, 'EXPOSURE')
Dateobs = astro.getheadervalues(source_Folder, Imagelist, 'DATE-OBS')
headerlist = astro.create_headers(object=Obj, exposure=np.mean(Exp), date_obs = np.min(Dateobs))

#--- saving final image.fit ---
astro.save_fits(image_final, headerlist, Folder+'image-final.fit')

raw_input("Press ENTER to close")

