# -*- coding: iso_8859_1 -*-

import astro

#------------------------------------------------------------------------------------
#	information on source FITS data
#------------------------------------------------------------------------------------

#--- input frames ---
source_Folder = u"C:\\Documents and Settings\Jrme\\Bureau\\21mar2011\\sources\\"
Darklist = ["Dark\\Dark-" + str(i+1) + ".fits" for i in range(20)]
Flatlist = ["flat-final-19mar2011.fit"]
Imagelist = ["Chryseis\\Chryseis-" + str(i+1) + ".fits" for i in range(353)]

#--- output frames ---
processing_Folder = u"C:\\Documents and Settings\Jrme\\Bureau\\21mar2011\\processing\\"
Savinglist = ["Chryseis\\Chryseis-calibrated-" + str(i+1) + ".fit" for i in range(353)]

#--- additional information (for FITS headers) ---
Tel = 'visac_short_f'
Obj = 'Chryseis - calibrated'

#------------------------------------------------------------------------------------
#	preparing calibration frames
#------------------------------------------------------------------------------------

darks = astro.getdata(source_Folder, Darklist)
dark_final = astro.add_sigma_clipping(darks, 3., 1)

flat = astro.getdata(processing_Folder, Flatlist)
flat = flat / astro.get_median(flat)

#------------------------------------------------------------------------------------
#	images calibration and saving
#------------------------------------------------------------------------------------

Exp = astro.getheadervalues(source_Folder, Imagelist, 'EXPOSURE')
Dateobs = astro.getheadervalues(source_Folder, Imagelist, 'DATE-OBS')

for i in range(0,len(Imagelist)):
	#loading
	images = astro.getdata(source_Folder, [Imagelist[i]])

	#calibration
	images_calib = (images - dark_final) / flat
	print 'dark and flat calibration ... done'

	#save image
	headerlist = astro.create_headers(object=Obj, telescope=Tel, exposure=Exp[i], date_obs = Dateobs[i])
	astro.save_fits(images_calib, headerlist, processing_Folder+Savinglist[i])
	print Savinglist[i] + ' saved'

raw_input("Press ENTER to close")

