# -*- coding: iso_8859_1 -*-

import astro
import numpy as np
import os, time

#-------------------------------------------------------------------------------------------
#	this scripts detects all new FITS files written to the specified folder
#	it computes their
#	- min, mean and max values
#-------------------------------------------------------------------------------------------

#path information
path_to_watch = u"C:\\Documents and Settings\\Jrme\\Bureau\\21fev2011" 

#-------------------------------------------------------------------------------------------

#loop to detect new fits files created in folder
before = dict ([(f, None) for f in os.listdir (path_to_watch)]) 
while 1: 
	time.sleep (10) 
	after = dict ([(f, None) for f in os.listdir (path_to_watch)]) 
	added = [f for f in after if not f in before] 
	#if added: print "Added: ", ", ".join (added) 	
	before = after 

	for f in added:
		if astro.check_extension(f):
			#loading new images
			images = astro.getdata(path_to_watch, [f])

			#calculating statistics
			mean = np.mean(np.mean(images, axis=1), axis=1)
			maxi = np.max(np.max(images, axis=1), axis=1)
			mini = np.min(np.min(images, axis=1), axis=1)

			print  "                   min: ", mini[0], "     max: ", maxi[0], "     mean: ", mean[0]